import java.util.*;
import java.awt.*;
import junior.*;

public class DynSinCos extends ReactiveApplet
{
    int rand(int n){ return (int)(Math.random()*1000)%n; }  

    Vector items = new Vector();
      
    public void paint(Graphics g){
       synchronized(items){
          Enumeration enum = items.elements();
          while(enum.hasMoreElements()) ((Ball)enum.nextElement()).paint(g);
       }
    } 
 
    void createBall(){ 
       Ball ball = new Ball(rand(size().width),rand(size().height));
       ball.radius = 5;
       items.addElement(ball);
       
       Program sin = 
           Jr.Seq(Jr.Await("sin"),
                  Jr.Loop(Jr.Seq(Jr.Atom(new Move(Ball.SINE)),Jr.Stop())));
       Program cos = 
           Jr.Seq(Jr.Await("cos"),
                  Jr.Loop(Jr.Seq(Jr.Atom(new Move(Ball.COSINE)),Jr.Stop())));
              
       machine.add(Jr.Link(ball,Jr.Par(sin,cos)));
    } 

    public void init(){
       Button sin = new Button("sin");
       Button cos = new Button("cos");
       Button sincos = new Button("sin+cos");
       Button start = new Button("new ball");
       
       Vector params = new Vector();
       params.addElement("sin");
       sin.addMouseListener(new GenerateAdapter(machine,params));
        
       params = new Vector();
       params.addElement("sin");
       params.addElement("cos");
       sincos.addMouseListener(new GenerateAdapter(machine,params));
       
       params = new Vector();
       params.addElement("cos");   
       cos.addMouseListener(new GenerateAdapter(machine,params));
    
       start.addMouseListener(new CreateBall(this));
       
       Panel p = new Panel();
       p.setBackground(Color.lightGray);
       setLayout(new BorderLayout());
       p.setLayout(new GridLayout(1,5,5,20));
       add("South",p);	
      
       p.add(sin);
       p.add(cos);
       p.add(sincos);
       p.add(start);
       
       //for(int i=0; i<1000; i++) createBall();
    }
}
